#!/usr/bin/php -q
<?php   
/***************************************************************************
 *            a2billing.php
 *
 *  Fri Nov 18 21:03:00 2005
 *  Copyright  2005  - Belaid Arezqui
 *  Email : areski [alt] gmail [_dot] com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  The GNU GPL license can be found at :http://www.gnu.org/copyleft/gpl.html
 *
 ****************************************************************************/

    declare(ticks = 1);
    if (function_exists('pcntl_signal')) {
		   pcntl_signal(SIGHUP,  SIG_IGN);
    }

     	error_reporting(E_ALL ^ (E_NOTICE | E_WARNING));
		
	include (dirname(__FILE__)."/libs_a2billing/db_php_lib/Class.Table.php");
	include (dirname(__FILE__)."/libs_a2billing/Class.A2Billing.php");
	include (dirname(__FILE__)."/libs_a2billing/Class.RateEngine.php");	    
	include (dirname(__FILE__)."/libs_a2billing/phpagi_2_14/phpagi.php");
	include (dirname(__FILE__)."/libs_a2billing/phpagi_2_14/phpagi-asmanager.php");


	$charge_callback=0;
	$G_startime = time();
	$agi_date = "Release : 13 August 2006";
	$agi_version = "1.2.3 (BrainCoral)";
	
	/********** 	 CREATE THE AGI INSTANCE + ANSWER THE CALL		**********/
	$agi = new AGI();
	
	
	if ($argc > 1 && is_numeric($argv[1]) && $argv[1] >= 0)
		$idconfig = $argv[1];
	else
		$idconfig = 1;
	$agi->verbose('line:'.__LINE__.' - '."IDCONFIG : $idconfig \n");
	
	
	if ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'did')			$mode = 'did';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'callback')		$mode = 'callback';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'cid-callback')	$mode = 'cid-callback';	
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'all-callback')	$mode = 'all-callback';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'predictivedialer')	$mode = 'predictivedialer';
	else $mode = 'standard';
	$agi->verbose('line:'.__LINE__.' - '."MODE : $mode \n");
	
	// get the area code for the cid-callback & all-callback
	if ($argc > 3 && strlen($argv[3]) > 0) $caller_areacode = $argv[3];
	
	
	$A2B = new A2Billing();
	$A2B -> load_conf($agi, NULL, 0, $idconfig);
	
	$A2B -> CC_TESTING = isset($A2B->agiconfig['debugshell']) && $A2B->agiconfig['debugshell'];	
	
	// TEST DID
	// if ($A2B -> CC_TESTING) $mode = 'did';
	
	//-- Print header
	if ($A2B->agiconfig['debug']>=1) $agi->verbose ('AGI Request:');
	if ($A2B->agiconfig['debug']>=1) $agi->verbose (print_r($agi->request, true));
	
	
	/* GET THE AGI PARAMETER */
	$A2B -> get_agi_request_parameter ($agi);
	
	//$A2B -> accountcode = '2222222222';
	
	if (!$A2B -> DbConnect()){						
		$agi-> stream_file('prepaid-final', '#');
		exit;					
	}
	
	$instance_table = new Table();
	$A2B -> set_instance_table ($instance_table);
		
function WriteLog ($line)
{
  $log = fopen("/var/log/asterisk/agi.log", "a+");
  $date_time = date ("d/m/Y H:i:s", time ());
  fputs($log, "${date_time}: ${line}\n");
  fflush($log);
  fclose ($log);
}


function SayMessagesCount ($agi, $oldOrNew, $count)
{
    switch ($count)
    {
    case 0:
        $agi->stream_file ("a2billing/voicemail/no_" . $oldOrNew . "_messages");
        break;
    case 1:
        $agi->stream_file ("a2billing/voicemail/1_" . $oldOrNew . "_message");
        break;
    case 2:
        $agi->stream_file ("a2billing/voicemail/2_" . $oldOrNew . "_messages");
        break;
    default:
        $agi->stream_file ("a2billing/voicemail/you_have");
        $agi->say_number ($count);
        $agi->stream_file ("a2billing/voicemail/" . $oldOrNew . "_messages");
        break;
    }
}

// Ask the caller to enter his password
$ok = false;
$errorCount = 0;
while (!$ok)
{
    $errorCount++;
    $resDTMF = $agi->get_data ("a2billing/voicemail/enter_password", 5000, 5);
    $password = $resDTMF ["result"];
    if ($password . ";" != ";")
    {
        $query = "SELECT id,voicemail FROM cc_card WHERE (userpass='" . $password . "')";
        $result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query);
        $ok = (is_array($result));
    }
    if ($ok)
    {
        $cardID = $result[0][0];
        $active = $result[0][1];
        WriteLog ("cardID is ${cardID}");
        WriteLog ("active is ${active}");
    }
    else
    {
        $agi->stream_file ("a2billing/voicemail/wrong_password");
        if ($errorCount < 3)
            $agi->stream_file ("a2billing/voicemail/try_again");
        else
        {
            $agi->stream_file ("a2billing/voicemail/too_many_errors");
            exit ();
        }
    }
}

if ($active == 0)
{
    // Mailbox is not active
    $agi->stream_file ("a2billing/voicemail/mailbox_not_active");
    exit ();
}

// Check how many new and heard messages the user has
$query = "SELECT Count(Id) FROM cc_voicemail WHERE ((Heard=0) AND (Deleted=0) AND (CardNumber=". $cardID . "));";
$result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query);
if (is_array ($result))
    $newMessagesCount = $result[0][0];
else
    $newMessagesCount = 0;
    
$query = "SELECT Count(Id) FROM cc_voicemail WHERE ((Heard=1) AND (Deleted=0) AND (CardNumber=". $cardID . "));";
$result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query);
if (is_array ($result))
    $oldMessagesCount = $result[0][0];
else
    $oldMessagesCount = 0;

// Tell the caller how many messages he has
if (($newMessagesCount == 0) && ($oldMessagesCount == 0))
{
    // No new or heard messages, exit the app
    $agi->stream_file ("a2billing/voicemail/no_messages");
    exit (1);
}
                            
for ($loop = 0; $loop < 2; $loop++)
{
    if (($loop == 0) && ($newMessagesCount == 0))
        continue;
    if (($loop == 1) && ($oldMessagesCount == 0))
        continue;
    $messagesCount = $loop == 0 ? $newMessagesCount : $oldMessagesCount;
    SayMessagesCount($agi, $loop == 0 ? "new" : "old", $messagesCount);
    $query = "SELECT Id,MessageFile,MessageDate,CallerID FROM cc_voicemail WHERE ((Heard=" . $loop . ") AND (Deleted=0) AND (CardNumber=". $cardID . "));";
    $resultArray = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query);
    
    for ($indx = 0; $indx < $messagesCount; $indx++)
    {
        $messageId = $resultArray [$indx][0];
        $fileName = $resultArray [$indx][1];
        $messageDateTime = $resultArray [$indx][2];
        $callerID = $resultArray [$indx][3];
        $year = substr($messageDateTime, 0, 4);
        $month = substr($messageDateTime, 5, 2);
        $day = substr($messageDateTime, 8, 2);
        $hour = substr($messageDateTime, 11, 2);
        $minute = substr($messageDateTime, 14, 2);
        $todayTS = strtotime (date ("Y-m-d") . " 00:00:00");
        $messageTS = strtotime ($year . "-" . $month . "-" . $day . " 00:00:00");
        WriteLog ("[a2billing_vm_hear] Message date is ${day}/${month}/${year} ${hour}:${minute}");
        WriteLog ("[a2billing_vm_hear] todayTS is ${todayTS}, messageTS is ${messageTS}");
        
        // Say the date and time of the message
        $resDTMF = $agi->stream_file ("a2billing/voicemail/received", "123");
        $input = $resDTMF ["result"];
        if ($todayTS != $messageTS)
        {
            // The message was not recieved toady, say the date
            if (($todayTS - $messageTS) == 60 * 60 * 24)
            {
                // The message was recieved yesterday
                if (($input == "") || (!$input))
                {
                    $resDTMF = $agi->stream_file ("a2billing/voicemail/yeasterday", "123");
                    $input = $resDTMF ["result"];
                }
            }
        }
        else
        {
            if (($input == "") || (!$input))
            {
                $resDTMF = $agi->stream_file ("a2billing/voicemail/at_date", "123");
                $input = $resDTMF ["result"];
            }
            if (($input == "") || (!$input))
            {
                $resDTMF = $agi->say_number ($day, "123");
                $input = $resDTMF ["result"];
            }
            if (($input == "") || (!$input))
            {
                $resDTMF = $agi->stream_file ("a2billing/voicemail/month_" . $month, "123");
                $input = $resDTMF ["result"];
            }
        }
        
        // Say the hour
        if (($input == "") || (!$input))
        {
            $resDTMF = $agi->stream_file ("a2billing/voicemail/at_hour", "123");
            $input = $resDTMF ["result"];
        }
        if (($input == "") || (!$input))
        {
            $resDTMF = $agi->say_number ($hour, "123");
            $input = $resDTMF ["result"];
        }
        if (($input == "") || (!$input))
        {
            if (($minute + 0) >= 10)
                $resDTMF = $agi->say_number ($minute, "123");
            else
                $resDTMF = $agi->say_digits ($minute, "123");
            $input = $resDTMF ["result"];
        }
        if ($input)
        {
            // The caller pressed something when the hour was said, check it out
            switch ($input)
            {
            case 50:
                // The caller pressed 2
                // Hear the next message
                continue;
            case 51:
                // The caller pressed 3
                // Delete the message
                $query = "UPDATE cc_voicemail SET Deleted=1 WHERE (Id=" . $messageId . ");";
                $result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query, 0);
                $agi->stream_file ("a2billing/voicemail/message_deleted");
                continue;
            }
        }

        // Say the caller ID
        if (($callerID) && ($callerID != ""))
        {
            $resDTMF = $agi->stream_file ("a2billing/voicemail/from_phone_number", "123");
            $input = $resDTMF ["result"];
            if (($input == "") || (!$input))
            {
                $resDTMF = $agi->say_digits ($callerID, "123");
                $input = $resDTMF ["result"];
            }
        }
        if ($input)
        {
            // The caller pressed something when the hour was said, check it out
            switch ($input)
            {
            case 50:
                // The caller pressed 2
                // Hear the next message
                continue;
            case 51:
                // The caller pressed 3
                // Delete the message
                $query = "UPDATE cc_voicemail SET Deleted=1 WHERE (Id=" . $messageId . ");";
                $result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query, 0);
                $agi->stream_file ("a2billing/voicemail/message_deleted");
                continue;
            }
        }
        
        // Play the message
        $resDTMF = $agi->stream_file ($fileName, "123");
        $input = $resDTMF ["result"];
        if ($loop == 0)
        {
            $query = "UPDATE cc_voicemail SET Heard=1 WHERE (Id=" . $messageId . ");";
            $result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query, 0);
        }
        if (($input == "") || (!$input))
        {
            $resDTMF = $agi->stream_file ("a2billing/voicemail/hear_messages_menu", "123");
            $input = $resDTMF ["result"];
        }
        
        switch ($input)
        {
        case 49:
            // The caller pressed 1
            // Hear the message again
            $indx--;
            break;
        case 51:
            // The caller pressed 3
            // Delete the message
            $query = "UPDATE cc_voicemail SET Deleted=1 WHERE (Id=" . $messageId . ");";
            $result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query, 0);
            $agi->stream_file ("a2billing/voicemail/message_deleted");
            break;
        }
    }
}

// No more messages - finish
$agi->stream_file ("a2billing/voicemail/no_more_messages");

?>
